
0000            00000  ;Screen FX 2
0000            00000  ;by Damian Scattergood
0000            00000  ;from Your Sinclair, Mar'89
0000            00000  ;
0000            00000  ;The Next Line Down/Up
0000            00000  ;and Scroll Down/Up routines
0000            00000  ;were incorrectly labelled in
0000            00000  ;the magazine.
0000            00000  ;
0000            00000  ;Execute this routine with HL
0000            00000  ;pointing to the screen address
0000            00000  ;and HL will return with the
0000            00000  ;next line down
0000            00000         org  60000
EA60            00000  ;Next Line Down
EA60 7C         00000  NXTC   ld   a,h
EA61 E607       00000         and  7
EA63 FE07       00000         cp   7
EA65 2802       00000         jr   z,LINEE
EA67 24         00000         inc  h
EA68 C9         00000         ret
EA69 7D         00000  LINEE  ld   a,l
EA6A E6E0       00000         and  224
EA6C FEE0       00000         cp   224
EA6E 2807       00000         jr   z,NCHAR
EA70 11E006     00000         ld   de,1760
EA73 A7         00000         and  a
EA74 ED52       00000         sbc  hl,de
EA76 C9         00000         ret
EA77 112000     00000  NCHAR  ld   de,32
EA7A 19         00000         add  hl,de
EA7B C9         00000         ret
EA7C            00000  ;
EA7C            00000  ;Next Line Up
EA7C 7C         00000  LSTC   ld   a,h
EA7D E607       00000         and  7
EA7F 2802       00000         jr   z,SALI
EA81 25         00000         dec  h
EA82 C9         00000         ret
EA83 7D         00000  SALI   ld   a,l
EA84 E6E0       00000         and  224
EA86 2807       00000         jr   z,SASE
EA88 11E006     00000         ld   de,1760
EA8B A7         00000         and  a
EA8C ED5A       00000         adc  hl,de
EA8E C9         00000         ret
EA8F 112000     00000  SASE   ld   de,32
EA92 A7         00000         and  a
EA93 ED52       00000         sbc  hl,de
EA95 C9         00000         ret
EA96            00000  ;
EA96            00000  ;This whopper (fnurk!) is the
EA96            00000  ;demo, using the previous two
EA96            00000  ;routines
EA96 CDD0EA     00000  DEMO   call FILL
EA99 0614       00000         ld   b,20
EA9B C5         00000  LOOP1  push bc
EA9C 210F40     00000         ld   hl,16384+15
EA9F 01C010     00000         ld   bc,10c0h
EAA2 CDDEEA     00000         call SLEFT
EAA5 211040     00000         ld   hl,16384+16
EAA8 01C010     00000         ld   bc,10c0h
EAAB CDF1EA     00000         call SRIGHT
EAAE C1         00000         pop  bc
EAAF 10EA       00000         djnz LOOP1
EAB1 0614       00000         ld   b,20
EAB3 C5         00000  LOOP2  push bc
EAB4 210040     00000         ld   hl,16384
EAB7 012060     00000         ld   bc,6020h
EABA CD2BEB     00000         call SUP4
EABD C1         00000         pop  bc
EABE 10F3       00000         djnz LOOP2
EAC0 0614       00000         ld   b,20
EAC2 C5         00000  LOOP3  push bc
EAC3 21A050     00000         ld   hl,20640
EAC6 012060     00000         ld   bc,6020h
EAC9 CD04EB     00000         call SDOWN4
EACC C1         00000         pop  bc
EACD 10F3       00000         djnz LOOP3
EACF C9         00000         ret
EAD0            00000  ;
EAD0 210040     00000  FILL   ld   hl,16384
EAD3 01FF17     00000         ld   bc,6143
EAD6 75         00000  LOOP4  ld   (hl),l
EAD7 23         00000         inc  hl
EAD8 0B         00000         dec  bc
EAD9 78         00000         ld   a,b
EADA B1         00000         or   c
EADB 20F9       00000         jr   nz,LOOP4
EADD C9         00000         ret
EADE            00000  ;
EADE E5         00000  SLEFT  push hl
EADF C5         00000  DEEP   push bc
EAE0 AF         00000         xor  a
EAE1 ED6F       00000  LOOP5  rld
EAE3 2B         00000         dec  hl
EAE4 10FB       00000         djnz LOOP5
EAE6 C1         00000         pop  bc
EAE7 E1         00000         pop  hl
EAE8 CD60EA     00000         call NXTC
EAEB E5         00000         push hl
EAEC 0D         00000         dec  c
EAED 20F0       00000         jr   nz,DEEP
EAEF E1         00000         pop  hl
EAF0 C9         00000         ret
EAF1            00000  ;
EAF1 E5         00000  SRIGHT push hl
EAF2 C5         00000  DEEP1  push bc
EAF3 AF         00000         xor  a
EAF4 ED67       00000  LOOP6  rrd
EAF6 23         00000         inc  hl
EAF7 10FB       00000         djnz LOOP6
EAF9 C1         00000         pop  bc
EAFA E1         00000         pop  hl
EAFB CD60EA     00000         call NXTC
EAFE E5         00000         push hl
EAFF 0D         00000         dec  c
EB00 20F0       00000         jr   nz,DEEP1
EB02 E1         00000         pop  hl
EB03 C9         00000         ret
EB04            00000  ;
EB04            00000  ;This scrolls up, not down
EB04 E5         00000  SDOWN4 push hl
EB05 CD7CEA     00000         call LSTC
EB08 CD7CEA     00000         call LSTC
EB0B CD7CEA     00000         call LSTC
EB0E CD7CEA     00000         call LSTC
EB11 EB         00000         ex   de,hl
EB12 E1         00000         pop  hl
EB13 EB         00000         ex   de,hl
EB14 C5         00000  LOOP7  push bc
EB15 D5         00000         push de
EB16 E5         00000         push hl
EB17 0600       00000         ld   b,0
EB19 EDB0       00000         ldir
EB1B E1         00000         pop  hl
EB1C CD7CEA     00000         call LSTC
EB1F D1         00000         pop  de
EB20 EB         00000         ex   de,hl
EB21 D5         00000         push de
EB22 CD7CEA     00000         call LSTC
EB25 D1         00000         pop  de
EB26 EB         00000         ex   de,hl
EB27 C1         00000         pop  bc
EB28 10EA       00000         djnz LOOP7
EB2A C9         00000         ret
EB2B            00000  ;
EB2B            00000  ;This scrolls down, not up
EB2B E5         00000  SUP4   push hl
EB2C CD60EA     00000         call NXTC
EB2F CD60EA     00000         call NXTC
EB32 CD60EA     00000         call NXTC
EB35 CD60EA     00000         call NXTC
EB38 EB         00000         ex   de,hl
EB39 E1         00000         pop  hl
EB3A EB         00000         ex   de,hl
EB3B C5         00000  LOOP8  push bc
EB3C D5         00000         push de
EB3D E5         00000         push hl
EB3E 0600       00000         ld   b,0
EB40 EDB0       00000         ldir
EB42 E1         00000         pop  hl
EB43 CD60EA     00000         call NXTC
EB46 D1         00000         pop  de
EB47 EB         00000         ex   de,hl
EB48 D5         00000         push de
EB49 CD60EA     00000         call NXTC
EB4C D1         00000         pop  de
EB4D EB         00000         ex   de,hl
EB4E C1         00000         pop  bc
EB4F 10EA       00000         djnz LOOP8
EB51 C9         00000         ret

00000 TOTAL ERRORS

DEEP         EADF                       DEEP1        EAF2
DEMO         EA96                       FILL         EAD0
LINEE        EA69                       LOOP1        EA9B
LOOP2        EAB3                       LOOP3        EAC2
LOOP4        EAD6                       LOOP5        EAE1
LOOP6        EAF4                       LOOP7        EB14
LOOP8        EB3B                       LSTC         EA7C
NCHAR        EA77                       NXTC         EA60
SALI         EA83                       SASE         EA8F
SDOWN4       EB04                       SLEFT        EADE
SRIGHT       EAF1                       SUP4         EB2B
